{$O-}

Unit kbd;

Interface

uses
  windows,Classes
;

var key_lock:byte = 0;
const
  _shift = 1;
  _alt   = 2 ;
  _ctrl  = 0;
  VK_1 = Byte('1');
  VK_2 = Byte('2');
  VK_3 = Byte('3');
  VK_4 = Byte('4');
  VK_5 = Byte('5');
  VK_6 = Byte('6');
  VK_7 = Byte('7');
  VK_8 = Byte('8');
  VK_9 = Byte('9');
  VK_0 = Byte('0');
  VK_A = Byte('A');
  VK_B = Byte('B');
  VK_C = Byte('C');
  VK_D = Byte('D');
  VK_E = Byte('E');
  VK_F = Byte('F');
  VK_G = Byte('G');
  VK_H = Byte('H');
  VK_I = Byte('I');
  VK_J = Byte('J');
  VK_K = Byte('K');
  VK_L = Byte('L');
  VK_M = Byte('M');
  VK_N = Byte('N');
  VK_O = Byte('O');
  VK_P = Byte('P');
  VK_Q = Byte('Q');
  VK_R = Byte('R');
  VK_S = Byte('S');
  VK_T = Byte('T');
  VK_U = Byte('U');
  VK_V = Byte('V');
  VK_W = Byte('W');
  VK_X = Byte('X');
  VK_Y = Byte('Y');
  VK_Z = Byte('Z');
  VK_LBracket =  $BA;
  VK_Rbracket =  $bb;
  VK_colon = $C0;
  VK_quote =$DE ;
  VK_Backslash =$BF ;
  VK_comma = $BC;
  VK_Period = $BE;
  VK_Slash = $BD ;
  VK_Rshift =$11  ;
  VK_Tilde = $DC ;
  VK_Minus =$DB  ;
  VK_Equal = $DD ;
  VK_Tab = $09 ;
  VK_escape = 27;
  VK_LALT   = 18;
  VK_RALT   = 18;

Type       (* SCANCODE DER TASTEN aus dem DOS EMULATOR*)
  scanCode = (
    kNone, kEsc, k1, k2, k3, k4, k5, k6, k7, k8, k9, k0, kMinus, kEqual,
    kBack, kTab, kQ, kW, kE, kR, kT, kY, kU, kI, kO, kP, kLBracket,
    kRBracket, kEnter, kCtrl, kA, kS, kD, kF, kG, kH, kJ, kK, kL, kColon,
    kQuote, kTilde, kLShift, kBackSlash, kZ, kX, kC, kV, kB, kN, kM, kComma,
    kPeriod, kSlash, kRShift, kPadStar, kAlt, kSpace, kCaps, kF1, kF2, kF3,
    kF4, kF5, kF6, kF7, kF8, kF9, kF10, kNum, kScroll, kHome, kUp, kPgUp,
    kPadMinus, kLf, kPad5, kRt, kPadPlus, kend, kDn, kPgDn, kIns, kDel,
    kSysReq, kUnknown55, kUnknown56, kF11, kF12,
    kNUMPAD0,kNUMPAD1,kNUMPAD2,kNUMPAD3,kNUMPAD4,kNUMPAD5,
    kNUMPAD6,kNUMPAD7,kNUMPAD8,kNUMPAD9);


Var
 tastatur,
 tastaturspeicher : set of scaNCODE;
 key_:array[0..$FF] of byte;
 shift_:array[0..2] of byte;

 letzte_taste : scanCode;
 nul_taste:tkeyboardstate;
 vk_press:byte = 0;

 x_late_key:byte = 0;
 kxlate:function(eing:integer;shift:byte):integer = nil;

function  test_Key(nKey: ScanCode):byte;
function  testmem_Key(nKey: ScanCode):byte;
procedure speicher_tasten;
procedure loesche_tasten;
function  get_key:byte;
procedure show_san;
procedure rest_keyboard;

function USxlate(eing:integer;shift:byte):integer;
function GBxlate(eing:integer;shift:byte):integer;
function GExlate(eing:integer;shift:byte):integer;

Implementation
function GExlate(eing:integer;shift:byte):integer;
begin
     result:=eing;
end;
function USxlate(eing:integer;shift:byte):integer;
begin
     case eing   // translate US codes to german codes
     of
       223:result:=220;
       221:result:=187;
       219:result:=186;
       220:result:=226;
       191:result:=189;
       189:result:=219;
       187:result:=221;
       186:result:=192;
        else result:=eing;
     end;
end;
function GBxlate(eing:integer;shift:byte):integer;
begin
    result:=eing;

    if shift = 0
    then
     case eing   // translate Uk codes to german codes
     of

       223:result:=220;
       222:result:=191;
       221:result:=187;
       220:result:=226;
       219:result:=186;
       191:result:=189;
       192:result:=222;
       189:result:=219;
       187:result:=221;
       186:result:=192;
     end;

    if shift = 1 // in england sind die verschoben !!
    then
     case eing   // translate Uk codes to german codes
     of
       223:result:=220;
       222:result:=191;
       221:result:=187;
       220:result:=226;
       219:result:=186;
       191:result:=189;
       192:result:=222;
       189:result:=219;
       187:result:=221;
       186:result:=192;
       55:result:=54;
     end;
end;


procedure rest_keyboard;
var i:byte;
begin
      for i:=0 to $ff do key_[i]:=0;
      tastatur:=[];
      for i:=0 to 2 do shift_[i]:=0;
end;

// key_[nn] wird fom form gefllt

function get_key;  // Historisch aus dos zeiten , bei neuer emulation NICHT verwenden !!!
(*  Rckgabe  0:keine Taste      1:Taste gedrckt *)
begin
    if vk_press  = 0 then tastatur:=[]
    else
       vk_press:=0;

       if key_[VK_numpad1] = 1   then tastatur:=tastatur+[Knumpad1];
       if key_[VK_numpad2] = 1   then tastatur:=tastatur+[Knumpad2];
       if key_[VK_numpad3] = 1   then tastatur:=tastatur+[Knumpad3];
       if key_[VK_numpad4] = 1   then tastatur:=tastatur+[Knumpad4];
       if key_[VK_numpad5] = 1   then tastatur:=tastatur+[Knumpad5];
       if key_[VK_numpad6] = 1   then tastatur:=tastatur+[Knumpad6];
       if key_[VK_numpad7] = 1   then tastatur:=tastatur+[Knumpad7];
       if key_[VK_numpad8] = 1   then tastatur:=tastatur+[Knumpad8];
       if key_[VK_numpad9] = 1   then tastatur:=tastatur+[Knumpad9];
       if key_[VK_numpad0] = 1   then tastatur:=tastatur+[Knumpad0];

       if key_[VK_1] = 1   then tastatur:=tastatur+[K1];
       if key_[VK_2] = 1   then tastatur:=tastatur+[K2];
       if key_[VK_3] = 1   then tastatur:=tastatur+[K3];
       if key_[VK_4] = 1   then tastatur:=tastatur+[K4];
       if key_[VK_5] = 1   then tastatur:=tastatur+[K5];
       if key_[VK_6] = 1   then tastatur:=tastatur+[K6];
       if key_[VK_7] = 1   then tastatur:=tastatur+[K7];
       if key_[VK_8] = 1   then tastatur:=tastatur+[K8];
       if key_[VK_9] = 1   then tastatur:=tastatur+[K9];
       if key_[VK_0] = 1   then tastatur:=tastatur+[K0];
       if key_[VK_A] = 1   then tastatur:=tastatur+[KA];


       if key_[VK_B] = 1   then tastatur:=tastatur+[KB];
       if key_[VK_C] = 1   then tastatur:=tastatur+[KC];
       if key_[VK_D] = 1   then tastatur:=tastatur+[KD];
       if key_[VK_E] = 1   then tastatur:=tastatur+[KE];
       if key_[VK_F] = 1   then tastatur:=tastatur+[KF];
       if key_[VK_G] = 1   then tastatur:=tastatur+[KG];
       if key_[VK_H] = 1   then tastatur:=tastatur+[KH];
       if key_[VK_I] = 1   then tastatur:=tastatur+[KI];
       if key_[VK_J] = 1   then tastatur:=tastatur+[KJ];
       if key_[VK_K] = 1   then tastatur:=tastatur+[KK];
       if key_[VK_L] = 1   then tastatur:=tastatur+[KL];
       if key_[VK_M] = 1   then tastatur:=tastatur+[KM];
       if key_[VK_N] = 1   then tastatur:=tastatur+[KN];
       if key_[VK_O] = 1   then tastatur:=tastatur+[KO];
       if key_[VK_P] = 1   then tastatur:=tastatur+[KP];
       if key_[VK_Q] = 1   then tastatur:=tastatur+[KQ];
       if key_[VK_R] = 1   then tastatur:=tastatur+[KR];
       if key_[VK_S] = 1   then tastatur:=tastatur+[KS];
       if key_[VK_T] = 1   then tastatur:=tastatur+[KT];
       if key_[VK_U] = 1   then tastatur:=tastatur+[KU];
       if key_[VK_V] = 1   then tastatur:=tastatur+[KV];
       if key_[VK_W] = 1   then tastatur:=tastatur+[KW];
       if key_[VK_X] = 1   then tastatur:=tastatur+[KX];
       if key_[VK_Y] = 1   then tastatur:=tastatur+[KY];
       if key_[VK_Z] = 1   then tastatur:=tastatur+[KZ];

       if key_[VK_F1] = 1   then tastatur:=tastatur+[KF1];
       if key_[VK_F2] = 1   then tastatur:=tastatur+[KF2];
       if key_[VK_F3] = 1   then tastatur:=tastatur+[KF3];
       if key_[VK_F4] = 1   then tastatur:=tastatur+[KF4];
       if key_[VK_F5] = 1   then tastatur:=tastatur+[KF5];
       if key_[VK_F6] = 1   then tastatur:=tastatur+[KF6];
       if key_[VK_F7] = 1   then tastatur:=tastatur+[KF7];
       if key_[VK_F8] = 1   then tastatur:=tastatur+[KF8];
       if key_[VK_F9] = 1   then tastatur:=tastatur+[KF9];
       if key_[VK_F10] = 1   then tastatur:=tastatur+[KF10];

       if key_[VK_Return] = 1   then tastatur:=tastatur+[Kenter];
       if key_[VK_end] = 1      then tastatur:=tastatur+[Kend];

       if key_[VK_UP] = 1   then tastatur:=tastatur+[Kup];
       if key_[VK_DOWN] = 1   then tastatur:=tastatur+[Kdn];
       if key_[VK_LEFT] = 1   then tastatur:=tastatur+[Klf];
       if key_[VK_right] = 1   then tastatur:=tastatur+[Krt];

       if key_[VK_home] = 1   then tastatur:=tastatur+[Khome];
       if key_[VK_back] = 1   then tastatur:=tastatur+[Kback];

       if key_[VK_space] = 1   then tastatur:=tastatur+[Kspace];
       if key_[VK_insert] = 1   then tastatur:=tastatur+[Kins];
       if key_[VK_delete] = 1   then tastatur:=tastatur+[Kdel];
       if key_[$BA] = 1   then tastatur:=tastatur+[KLBracket];
       if key_[$bb] = 1   then tastatur:=tastatur+[KRbracket];
       if key_[VK_colon] = 1   then tastatur:=tastatur+[Kcolon];
       if key_[VK_quote] = 1   then tastatur:=tastatur+[Kquote];
       if key_[VK_Backslash] = 1   then tastatur:=tastatur+[KBackslash];
       if key_[VK_comma] = 1   then tastatur:=tastatur+[Kcomma];
       if key_[VK_Period] = 1   then tastatur:=tastatur+[KPeriod];
       if key_[VK_Slash] = 1   then tastatur:=tastatur+[KSlash];
       if key_[$11] = 1   then tastatur:=tastatur+[KRshift];
       if key_[VK_Tilde] = 1   then tastatur:=tastatur+[KTilde];
       if key_[VK_Minus] = 1   then tastatur:=tastatur+[KMinus];
       if key_[VK_Equal] = 1   then tastatur:=tastatur+[KEqual];
       if key_[VK_Tab] = 1   then tastatur:=tastatur+[KTab];
       (* $11 > ALTGR ====> RShift *)

       if shift_[0] = 1 then  tastatur:=tastatur+[Kctrl];
       if shift_[1] = 1 then  tastatur:=tastatur+[Klshift];
       if shift_[2] = 1 then  tastatur:=tastatur+[Kalt];

       if tastatur <> [] then get_key:=1 else get_key:=0;
end;

function test_Key(nKey: ScanCode):byte;
begin
  test_key:=0;                  (* TASTE NICHT VORHANDEN *)
  if nKey in tastatur
  then
     test_key:=1;
end;

procedure show_san;
var i:byte;
begin
     writeln('');
     for i:=0 to 255
     do
        writeln(test_key(ka))
end;



function testmem_Key(nKey: ScanCode):byte;
begin
  testmem_key:=0;                  (* TASTE NICHT VORHANDEN *)
  if nKey in tastaturspeicher
  then
     testmem_key:=1;
end;


procedure speicher_tasten;
begin
      tastaturspeicher:=tastatur;
end;

procedure loesche_tasten;
begin
      tastaturspeicher:=[];
      tastatur:=[];
end;

initialization
            //  kxlate:=gexlate;
end.
