unit helper;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg,ExtCtrls,udibsurf, StdCtrls, Menus,sercom,Clipbrd, ComCtrls,Registry,
  m0609fnt;

const schwarz=0;
      weiss=8;

var
  x:word;
  y:integer;

  port:SerialPtr;
  IN_,out_:integer;
  err:SerialErr;
  data:char;
  d:array[1..8]of byte;
  brk:byte = 0;
  ex:byte = 0;
  offs:word = 300; // 3V
  maxw:word =1000;  //10V   // maximaler wert
  skip:word = 1;
  tik2:integer = 0;
  mul:real;
  COMlist:TStringlist;
  mittelwert_zahl:byte = 1;
  Multiplikator:real=10;
  maxvalues:byte = 29;
  paused:byte = 1;

  akt_rec_pos:integer = 0;

  mode :byte = 0;   // o RS232 , 1 File;

  tick,tick1:integer;

  running_readdatas:byte = 0;

   draw_count,          // wird fr die mausanzeige der werte gebraucht:
   draw_start:integer;

  pal_change:array[0..40] of byte;

  value      :array[0..100] of dword;
  value_old  :array[0..100] of dword;
  value_float:array[0..100] of real;
  y_old      :array[0..100] of word;
  y_min      :array[0..100] of word;
  y_max      :array[0..100] of word;
  y_offs     :array[0..100] of real;


  //v_mem      :^v_array;
  v_mem      :array of byte;//array[0..y_w*x_w] of byte;     // wird fr das sichern des bildes gebraucht

  Rec_list:TStringList;

  framelaenge:byte = 0;

type T_str  = array[1 .. 8] of char;


const
  Mz700Colors: array[0..31] of array[1..3] of Byte =
    ( (* MZ700 colours *)
     ( $00, $00, $00),( 000, 00, $F0),
     ( $F0, 000, 00),( $F0, 000, $F0),
     ( 00, $f0, 00),( 00, $F0, $F0),
     ( $f0, $f0, 0),( $ff, $0f, $0f),

     (* Brigth colours *)
     ( 128,128,128), ( $00, $00, $ff),
     ( $ff, $00, $00), ( $ff, $00, $ff),
     ( $00, $ff, $00), ( $00, $ff, $ff),
     ( $ff, $ff, $00), ( $Af, $0f, $ff),

     ( $AA, $AA, $AA),( $AA, $AA, $F0),
     ( $F0, $AA, $AA),( $F0, $AA, $F0),
     ( $AA, $f0, $AA),( $AA, $F0, $F0),
     ( $f0, $f0, $AA),( $00, $DD, $AA),


     ( 128,128,128), ( $00, $00, $ff),
     ( $ff, $cc, $cc), ( $ff,  $cc, $ff),
     ( $cc, $ff, $cc), ( $cc, $ff, $ff),
     ( $00, $00,  $cc), ( $FB, $FB, $EB));

filler = '                                  ';

procedure EnumComPorts(Ports: TStrings);     // danke an Brainshock ...
procedure save_log(flag:byte);
function  get_sec(eing:real):byte;
Function  SaveBitmapAsJPEG(BMP:TBitmap;Filename:String):Boolean;
function select_file:string;

implementation

Function SaveBitmapAsJPEG(BMP:TBitmap;Filename:String):Boolean;
Var Bild:TJPEGImage;
Begin
  Result:=false;
  Bild:=TJPEGImage.Create;
  Try
    Bild.Assign(BMP);
    Bild.SaveToFile(filename);
  Finally
    FreeAndNil(Bild);
    Result:=true;
  End;
End;

function get_sec(eing:real):byte;
begin
     result:=trunc((eing-trunc(eing))*100000) mod 60
end;

procedure save_log(flag:byte);
var t_zeit: ^t_str;
    zeit  :string[8];
    f_name:string;
begin
      if rec_list.Count = 0 then exit; // liste ist leer ? 
      t_zeit:=@zeit;
      zeit:=timetostr(now);
      t_zeit^[4]:='_';
      t_zeit^[7]:='_';
      f_name:='Values'+Zeit+'.txt';
      rec_list.SaveToFile(f_name);
      rec_list.Clear;
      if flag = 1 then showmessage(f_name);
end;


procedure EnumComPorts(Ports: TStrings);     // danke an Brainshock ...
var
  KeyHandle: HKEY;
  ErrCode, Index: Integer;
  ValueName, Data: string;
  ValueLen, DataLen, ValueType: DWORD;
  TmpPorts: TStringList;
begin
  ErrCode := RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'HARDWARE\DEVICEMAP\SERIALCOMM',
    0, KEY_READ, KeyHandle);

  if ErrCode <> ERROR_SUCCESS then
    raise Exception.Create('Fehler beim Registry ffnen!');

  TmpPorts := TStringList.Create;
  try
    Index := 0;
    repeat
      ValueLen := 256;
      DataLen := 256;
      SetLength(ValueName, ValueLen);
      SetLength(Data, DataLen);
      ErrCode := RegEnumValue(
        KeyHandle,
        Index,
        PChar(ValueName),
        Cardinal(ValueLen),
        nil,
        @ValueType,
        PByte(PChar(Data)),
        @DataLen);

      if ErrCode = ERROR_SUCCESS then
      begin
        SetLength(Data, DataLen - 1);
        TmpPorts.Add(Data);
        Inc(Index);
      end
      else
        if ErrCode <> ERROR_NO_MORE_ITEMS then
          raise Exception.Create('Fehler Registry auslesen!');

    until (ErrCode <> ERROR_SUCCESS) ;

    TmpPorts.add('FILE');
    TmpPorts.Sort;
    Ports.Assign(TmpPorts);
  finally
    RegCloseKey(KeyHandle);
    TmpPorts.Free;
  end;
end;

function select_file:string;
var  openDialog : topendialog;
begin
     openDialog := TOpenDialog.Create(application);
     openDialog.InitialDir := GetCurrentDir;
     openDialog.Options := [ofFileMustExist];
     openDialog.Filter :='LogText|*.txt';
     openDialog.FilterIndex := 2;
     if openDialog.Execute
     then
        begin
                result:=openDialog.FileName;
                if not FileExists(openDialog.FileName)
                then
                    result:='';
        end
     else result:='';
     openDialog.Free;

end;


end.
