unit utils;

interface

uses classes,windows,sysutils,Messages ,Dialogs;

procedure gettime(var hh,mm,sec,hs:word);
function  clearValue(eingang:string):string;
function  flip(eingang:byte):byte;
function  Upper(eingang:string):string;
Function  AllTrim (S:String):String;
function  HexToInt(S: String):LongInt;
function  Bit(nByte1, nByte2: Byte): Byte;
function  bin(eing:byte):string;
function  r_word(adr:pointer):word;       (* 16 Bit speicherzugriff *)
procedure w_word(adr:pointer;eing:word);
procedure loadrom(name:string;start:word;dest:pointer);

var RFS : TFileStream;

implementation

function Bit(nByte1, nByte2: Byte): Byte;
const
  aBytes: array[0..7] of Byte = (1,2,4,8,16,32,64,128);
begin
  if (nByte1 and aBytes[nByte2])=0 then
    Bit := 0
  else
    Bit := 1
end;

function bin(eing:byte):string;
var n:byte;
begin
         bin:='00000000';
         for n:=0 to 7             (* Wert x in eine Binrwert umwandeln *)
               do
                  if (eing shr n and 1) = 1 (* AND verknpfung positiv = Log _1_ *)
                  then
                      bin[8-n]:='1';
end;

procedure loadrom(name:string;start:word;dest:pointer);
                                      (* UNIVERSAL *)
type  t = array[0..$FFFF+2] of byte;
var   p:^t;
begin
     if fileExists(name)
      then
        begin
              p:=dest;
              RFS:=TFileStream.Create(name, fmOpenRead);
              RFS.Read(P^[start], RFS.Size);
              RFS.Free;
        end
            else
               begin
                 showmessage('ROM nicht vorhanden / Rom not exist :'+name+'!!!');
               end;
end;

function r_word(adr:pointer):word;
type  r_w = word;
var mem_word:^r_w;
begin
      mem_word:=adr;
      r_word:=mem_word^;
end;

procedure w_word(adr:pointer;eing:word);

type  r_w = word;
var mem_word:^r_w;
begin
      mem_word:=adr;
      mem_word^:=eing;
end;

procedure out(addr:word;wert:byte);
begin
     asm
        mov dx,addr;
        mov al,wert;
        out DX,AL;
     end;
end;

function inp(addr:word):byte;
var t:byte;
begin
     asm
        mov dx,addr;
        in al,DX;
        mov t,al;
     end;
     inp:=t;
end;

function clearValue(eingang:string):string;
var te:string;  I:byte;
begin
      te:='';
      for i:=1 to Length(eingang)
      do
        if upcase(eingang[i]) in ['A'..'F','0'..'9','$'] then
          te:=te+eingang[i];

        clearValue:=te;
end;

procedure gettime(var hh,mm,sec,hs:word);
var Present: TDateTime;
begin
      Present:= Now;
      DecodeTime(Present, Hh,mm,Sec,hs);
end;

function  flip(eingang:byte):byte;
var i,v:byte;
begin
      v:=0;
     for i:=0 to 7
     do
        v:=v or (((eingang shr i) and 1) shl (7-i));
     result:=v;
end;

function Upper(eingang:string):string;
var i:byte;
    b:String;
begin
     b:='';
     for i:=1 to length(eingang)
     do
       b:=b+upcase(eingang[i]);
     result:=b;
end;


function HexToInt(S: String): LongInt;
 const
   cHexDig: String[16] = '0123456789ABCDEF';
 var
   nMult,
   nAux: LongInt;
   I, nPos: Integer;
 begin
   S := AllTrim(S);
   nAux := 0;
   nMult := 1;
   for i := Length(S) downto 1 do begin
     nPos := Pos(S[i], cHexDig);
     if nPos<>0 then
       nAux := nAux+(nPos-1)*nMult;
     nMult := nMult*16;
   end;
   HexToInt := nAux;
 end;

Function AllTrim (S:String):String;
Begin
While (Length(S)>0) and (S[1]=#32) do
      Delete (S,1,1);
While (Length(S)>0) and (S[Length(S)]=#32) do
      Delete (S,Length(S),1);
AllTrim := S
End;


end.
