unit UDIBSurf;

// new dirty draw_lines  6 feb 07
// fr mode null und 3 noch einfgen !!
// last modify 09.04.07
// franzenm@web.de
//
interface

uses
  Windows,Sysutils,Graphics,USprite,UMAMEChr,Dialogs;

const
     TRANSPARENCY_NONE   = 0;
     TRANSPARENCY_PEN    = 1;
     TRANSPARENCY_color  = 2;
     TRANSPARENCY_FULL   = 3;
     TRANSPARENCY_NCOLOR = 4;
     TRANSPARENCY_COLOR_set = 5;
     TRANSPARENCY_FULL_color = 6;
     Dummy             = 0;

type
 TGDIBitMapInfoHeader = record
   biSize: Longint;
   biWidth: Longint;
   biHeight: Longint;
   biPlanes: Word;
   biBitCount: Word;
   biCompression: Longint;
   biSizeImage: Longint;
   biXPelsPerMeter: Longint;
   biYPelsPerMeter: Longint;
   biClrUsed: Longint;
   biClrImportant: Longint;
 end;

 TGDIPaletteEntry = record
   peRed: Byte;
   peGreen: Byte;
   peBlue: Byte;
   peFlags: Byte;
 end;

 TPalEntries   = array[0..255] of TPaletteEntry;

 TMyLogPalette = record
    palVersion    : Word;
    palNumEntries : Word;
    palEntry      : TPalEntries;
  end;

  TPalIndices    = array[0..255] of word;
  PMyBitmapInfo  = ^TMyBitmapInfo;
  TMyBitmapInfo  = record
    BMIheader   : TGDIBitMapInfoHeader;
    BMIcolors   : TPalIndices;
  end;
 amemory =array[0..$FFFF] of Byte;
 ByteArray = ^amemory;

rectangle = record
	    min_x,
            max_x,
            min_y,
            max_y:word;
          end;


   pale = record
                  r,
                  g,
                  b:byte;
               end;

   OPENpale = record
                  r,
                  g,
                  b:real;
               end;

  dpale_ = array[0..3*255] of byte;
  dpal = ^dpale_;

var
  apalette:array[0..255] of pale;
  openglpal:array[0..255] of OPENpale; //farbtafel fr OPENGL
  C_mode:byte = 1;

  C16Bit_farbtabelle:array[0..$FFFF] of word;
  palette: dpal;
  palset:byte;
  pal_changed:byte = 0;
  DIBbits: Pointer;
  DIBhandle: Integer;
  DIBheader: TMyBitmapInfo;
  OLDPalette,
  DIBhPalette: Integer;
  DIBDC: Integer;
  DIBWidth: integer;
  DIBHeight: integer;
  DIBWidth_b: integer;
  DIBSize: integer;
  OLDHandle: Integer;
  aColorLookUpTable: array[0..1023] of Byte;
  colorram    :ByteArray = nil;
  colorram_2  :ByteArray = nil;
  spriteram   :ByteArray = nil;
  spriteram_2 :ByteArray = nil;
  videoram    :ByteArray = nil;
  videoram_2  :ByteArray = nil;
  paletteram  :ByteArray = nil;
  paletteram_2:ByteArray = nil;
  characterram:ByteArray = nil;
  sharedram   :ByteArray = nil;
  sr          :ByteArray = nil;

  aNewHPalette: TMyLogPalette;
  agRAU : TMyLogPalette;
  aGrUEN: TMyLogPalette;
  aAMBER: TMyLogPalette;

  RC:HGLRC;
  screenDC:HDC;
  nScreen: HDC;
  pal_entrys:byte = 15;
  nScrdx,nscrdy :byte;
  nScrW,nScrH:word;
  OENGL_AKTIVE:byte =0;
  Bit_deep:byte =8;


  plot                  :procedure(x,y:integer; b:byte);
  start_driver          :procedure = NIL;
  end_driver            :procedure = NIL;

  dirty_line            :array[0..1024] of byte;
  dirty_lines_on        :byte = 0;

  const dirty_line_on  = 1;
        dirty_line_off = 0;



procedure initpal(pal_entrys:byte);
procedure CreateDIBSurf(oNewHPalette:TMyLogPalette; aW, aH: Word;bit:byte);
procedure copy_dub_scr(DC: Integer;scr_dub:byte;DIBWidth,DIBHeight,ClientWidth,Clientheight:word);
procedure DestroyDIBSurf;
procedure change_c_mode(eing:byte);
procedure FillSurface(nColor: Byte);
procedure FillSurface64(nColor: word);
procedure Fillline(nColor: Byte;line,numbers:integer);
procedure Fillline64(nColor: word;line,numbers:integer);
procedure update_pal;
procedure set_bmp_deep(eing:byte);
procedure palette_set_color(nr,r,g,b:byte);
procedure palette_set_color16(nr:word;r,g,b:byte);

procedure drawgfx_core(dest:pointer;K:PGFXElement;Code:word; nColor:Word;ix,iy:byte; X,Y:Integer;clip:byte;ransparency,transparent_color:word);
procedure drawgfx_core16(dest:pointer;K:PGFXElement;Code:word; nColor:Word;ix,iy:byte; X,Y:Integer;clip:byte;ransparency,transparent_color:word);
procedure changecolor_xxxxBBBBGGGGRRRR(color:byte;data:word);
procedure changecolor_xxxxRRRRBBBBGGGG(color:byte;data:word);
Procedure paletteram_BBGGGRRR_w(offs:word;data:byte);
function MAKE_RGB(r,g,b:byte):integer;


procedure SetPixel64K(x,y:integer; b:byte);
procedure SetPixel64K_16(x,y:integer; b:word);
procedure SetPixelFast_a(x,y:integer; b:byte;adresse:pointer);
procedure SetPixelFast_mz800(x,y:integer; b:byte);


implementation


type
  AByte = array[0..0] of Byte;
  PByte = ^AByte;
  Fa = array[0..4*$FFFF]of byte;
  fb = array [0..2*$FFFF] of word;


const
  BI_RGB = 0;
  BI_RLE8 = 1;
  BI_RLE4 = 2;
  BI_BITFIELDS = 3;
  DIB_RGB_COLORS = 0;     { color table in RGBs  }
  DIB_PAL_COLORS = 1;     { color table in palette indices  }
  SRCCOPY     = $00CC0020;     { dest = source                    }

procedure set_bmp_deep(eing:byte);
begin
     Bit_deep:=eing;
     case eing
     of
         8,16,24:;
     else
         bit_deep:=8;
     end;
end;
function MAKE_RGB(r,g,b:byte):integer;
begin
 	result:=((r shl 16) or (g shl 8) or b);
end;

procedure palette_set_color16(nr:word;r,g,b:byte);
begin
      // hier leider nur 15 bit 
      C16Bit_farbtabelle[nr]:=
                            (b shr 3)
                            or
                            (g shr 3) shl 5
                            or
                            (r shr 3) shl 10;

end;

procedure CreateDIBSurf(oNewHPalette:TMyLogPalette; aW, aH: Word;BIT:byte);
var lp1 : integer;
begin
  DIBbits      := nil;
  DIBhandle    := 0;
  OLDPalette   := 0;
  DIBhpalette  := CreatePalette(PLogPalette(@oNewHPalette)^);
  DIBDC        := CreateCompatibleDC(0);
  if palset <> 0 then OLDPalette:= SelectPalette(DIBDC, DIBhpalette, true);
  with DIBheader do begin
    with bmiHeader do begin
      biSize          := sizeof(TGDIBitMapInfoHeader);
      biWidth         := aW;
      biHeight        := aH;
      biPlanes        := 1;
      biBitCount      := Bit_deep;
      biCompression   := BI_RGB;
      biSizeImage     := 0;
      biXPelsPerMeter := 0;
      biYPelsPerMeter := 0;
      biClrUsed       := 0;
      biClrImportant  := 0;
    end;
    for lp1:=0 to 255 do BMIcolors[lp1] := (lp1+0) and 255; { pal_indices }
  end;

  DIBWidth   := aW;
  DIBHeight  := aH;
  DIBWidth_b := ((DIBWidth+3) shr 2) shl 2;
  DIBSize    := DIBWidth_b*DIBHeight;
  DIBWidth   := ((DIBWidth+3) shr 2) shl 2;

  if OLDHandle<>0 then SelectObject(DIBDC, OLDHandle);
  if DIBhandle<>0 then DeleteObject(DIBhandle);


  DIBheader.BMIheader.biWidth  := DIBWidth;
  DIBheader.BMIheader.biHeight :=-DIBHeight;  { Top down for me please...}
  { the minus sign may or may not be necessary on your machine - I'm not sure }
  { without it - the DIB is bottom up - See old WinG documentation            }
  DIBhandle := CreateDIBSection(DIBDC,pBitmapInfo(@DIBheader)^,DIB_PAL_COLORS,DIBbits,0,0);
  OLDHandle := SelectObject(DIBDC,DIBhandle);

  fillchar(dirty_line,1024,0); // zerro draw all lines !!!
  dirty_lines_on:=0;    // = 1 it will bee use dirty lines
  MDRV_SCREEN_SIZE(aW, aH);

end;


procedure DestroyDIBSurf;
begin
  //if RC<>0 then DestroyRenderingContext(RC);
  if OLDHandle<>0    then SelectObject(DIBDC, OLDHandle);
  if DIBhandle<>0    then DeleteObject(DIBhandle);
  if DIBhpalette<>0  then SelectPalette(DIBDC,DIBhpalette,false);
  if DIBhpalette<>0  then DeleteObject(DIBhpalette);

  DeleteDC(DIBDC);
end;

procedure update_pal;
begin
    if pal_changed = 1
     then
       begin
            pal_changed:=0;
            DestroyDIBSurf;

            initpal(pal_entrys);

            CreateDIBSurf(aNewHPalette,DIBWidth,DIBHeight,bit_deep);
       end;
end;

procedure change_c_mode(eing:byte);
begin
 if palset <> 0 then
 begin
     pal_changed:=1;
     c_mode:=eing;
     DestroyDIBSurf;  // ertmal den alten Raus  r
     case eing
     of
       1:CreateDIBSurf(aNewHPalette,DIBWidth,DIBHeight,bit_deep);
       2:CreateDIBSurf(agrau,DIBWidth,DIBHeight,bit_deep);
       3:CreateDIBSurf(aamber,DIBWidth,DIBHeight,bit_deep);
       4:CreateDIBSurf(agruen,DIBWidth,DIBHeight,bit_deep);
       5:CreateDIBSurf(aNewHPalette,DIBWidth,DIBHeight,bit_deep);
     end;
 end
     else
          showmessage('Diese Maschine untersttzt keine Graustufen');
end;




// noch nicht fertig von mame bernommen
// drawgfx_core       (dest,  gfx,            code,      color  ,    flipx,flipy,     sx,sy,   clip,transparency,transparent_color,1);
procedure drawgfx_core(dest:pointer;K:PGFXElement;
                                    Code:word;
                                    nColor:Word;
                                    ix,iy:byte;
                                    X,Y:Integer;
                                    clip:byte;
                                    ransparency,
                                    transparent_color:word);
var
  lin,col,c: Byte;
  oMem:^TMemory;
  amem:PSprite;
  ctab:ctable;
  Pos,Tpos,cpos:integer;
begin

oMem  :=dest; amem:=k.gfxdata^[code and (k.total_elements-1) ];
Pos:=(x+y*DIBWidth_b);
if iy > 0 then pos:=Pos+(DIBWidth_b)*(amem^.H-1);
cpos:=0;  lin:=0; ctab:=k.colortable;
if k.planes > 1 then ncolor:=ncolor shl (k.planes);

fillchar(dirty_line[y],amem^.H,0); // anzahl der y-zeilen
repeat
      col:=0;
      repeat
            if ix = 0
            then  Tpos:=pos + col  // an der x_achse spiegeln
            else  Tpos:=pos - col + amem^.W - 1;
            c:=amem^.adata[CPOS];      // Farbe in der spritetabelle 8Bit
            if c > 0
            then
                 begin

                     if  ctab = nil
                     then c:=c + ncolor
                     else c:=ctab^[c + ncolor]; // farbe aus bersetzungstabelle eintragen

                     //c:=c shl 1;
                     case  ransparency
                     of
                       TRANSPARENCY_COLOR:
                           if c <>  transparent_color
                            then
                               oMem[Tpos]:=c;     // Farbe

                       TRANSPARENCY_PEN:
                           if c <> 0
                            then
                               oMem[Tpos]:=c;     // Farbe


                       TRANSPARENCY_NONE:
                              oMem[Tpos]:=c;
                       end
                 end
            else
                 if  ransparency = TRANSPARENCY_NONE
                 then  oMem[Tpos]:=transparent_color;

            inc(col);                  // spalte
            inc(cpos);                 // im sprite

      until col = (amem^.W);

      if iy > 0                        // Spiegeln um die y-achse
      then dec(pos,DIBWidth_b)
      else inc(pos,DIBWidth_b);        // neue zeile im Bildschirm
      inc(lin);                        // nchste zeile
until lin = (amem^.H);                 // 0 - (n-1)
end;

procedure drawgfx_core16(dest:pointer;K:PGFXElement;
                                    Code:word;
                                    nColor:Word;
                                    ix,iy:byte;
                                    X,Y:Integer;
                                    clip:byte;
                                    ransparency,
                                    transparent_color:word);
var
  lin,col,c:word;
  oMem:^fb;
  amem:PSprite;
  ctab:ctable;
  Pos,Tpos,cpos:integer;
begin
oMem  :=dest; amem:=k.gfxdata^[code and (k.total_elements-1) ];
Pos:=(x+y*DIBWidth_b);
if iy > 0 then pos:=Pos+(DIBWidth_b)*(amem^.H-1);
cpos:=0;  lin:=0; ctab:=k.colortable;
if k.planes > 1 then ncolor:=ncolor shl (k.planes);
fillchar(dirty_line[y],amem^.H,0); // anzahl der y-zeilen

repeat
      col:=0;
      repeat
            if ix = 0
            then  Tpos:=pos + col  // an der x_achse spiegeln
            else  Tpos:=pos - col + amem^.W - 1;
            c:=amem^.adata[CPOS];      // Farbe in der spritetabelle 8Bit
            if c > 0
            then
                 begin

                     if  ctab = nil
                     then c:=c + ncolor
                     else c:=ctab^[c + ncolor]; // farbe aus bersetzungstabelle eintragen

                     case  ransparency
                     of

                       TRANSPARENCY_COLOR:
                           if c <>  transparent_color
                            then
                               oMem[Tpos]:=C16Bit_farbtabelle[c];     // Farbe

                       TRANSPARENCY_NCOLOR:
                         begin
                           if c <> ncolor
                            then
                               oMem[Tpos]:=C16Bit_farbtabelle[c];     // Farbe
                        end;

                       TRANSPARENCY_PEN:
                           if c <> 0
                            then
                               oMem[Tpos]:=C16Bit_farbtabelle[c];     // Farbe

                       TRANSPARENCY_FULL:
                           if C16Bit_farbtabelle[c] <> 0
                            then
                               oMem[Tpos]:=C16Bit_farbtabelle[c];     // Farbe
                       TRANSPARENCY_FULL_color:
                        if C16Bit_farbtabelle[c] <>  transparent_color
                            then
                               oMem[Tpos]:=C16Bit_farbtabelle[c];     // Farbe

                       TRANSPARENCY_NONE:
                               oMem[Tpos]:=C16Bit_farbtabelle[c];
                       end
                 end
            else
                 if  ransparency = TRANSPARENCY_NONE
                 then  oMem[Tpos]:=C16Bit_farbtabelle[transparent_color];

            inc(col);                  // spalte
            inc(cpos);                 // im sprite

      until col = (amem^.W);

      if iy > 0                        // Spiegeln um die y-achse
      then dec(pos,DIBWidth_b)
      else inc(pos,DIBWidth_b);        // neue zeile im Bildschirm
      inc(lin);                        // nchste zeile
until lin = (amem^.H);                 // 0 - (n-1)
end;



procedure SetPixel64K(x,y:integer; b:byte);
var feld:^FA;
begin
     dirty_line[y]:=0;
     feld:=DIBBits;
     feld^[((y*DIBWidth_b+x) and $FFFF)]:=b;
end;

procedure SetPixel64K_16(x,y:integer; b:word);
var feld:^Fb;
begin      // farbtabelle fehlt noch !!
     dirty_line[y]:=0;
     feld:=DIBBits;
     feld^[((y*DIBWidth_b+x) and $FFFF)]:=C16Bit_farbtabelle[b];
end;


procedure SetPixelFast_a(x,y:integer; b:byte;adresse:pointer); //assembler;
var feld:^FA;
begin
     dirty_line[y]:=0;
     feld:=adresse;
     feld^[(y*DIBWidth_b+x) and $FFFF]:=b;
end;

procedure SetPixelFast_mz800(x,y:integer; b:byte);
var feld:^FA;
begin
     dirty_line[y]:=0;
     feld:=DIBBits;
     feld^[y*DIBWidth_b+x]:=b;
end;

procedure FillSurface(nColor: Byte);
begin
  FillChar(DIBbits^, DIBSize, nColor);
end;

procedure FillSurface64(nColor: word);
begin
  FillChar(DIBbits^, DIBSize*2, nColor);
end;

procedure Fillline(nColor: Byte;line,numbers:integer);
var feld:^byte;
begin
  feld:=DIBbits;
  inc(feld,line*DIBWidth_b);
  FillChar(feld^,DIBWidth_b*numbers, nColor);
end;

procedure Fillline64(nColor: word;line,numbers:integer);
var feld:^byte;
begin
  feld:=DIBbits;
  inc(feld,line*DIBWidth_b*2);
  FillChar(feld^,DIBWidth_b*numbers,nColor);
end;

procedure initpal(pal_entrys:byte);
  var I,c:byte;
begin

    aNewHPalette.palVersion := $300;
    aNewHPalette.palNumEntries := 256;

    for i := 0 to 245 do
         aNewHPalette.PalEntry[i].peFlags := PC_RESERVED;


    for i:=0 to pal_entrys
    do
      begin
           aNewHPalette.PalEntry[i].peRed   :=apalette[i].r;
           aNewHPalette.palEntry[i].peGreen :=apalette[i].g;
           aNewHPalette.PalEntry[i].peBlue  :=apalette[i].B;
           palette_set_color16(i,apalette[i].r,apalette[i].g,apalette[i].b);
      end;

// Grau
   agrau:=aNewHPalette;
   for i:=0 to pal_entrys
    do
      begin
           c:=trunc(apalette[i].r*0.2+apalette[i].g*0.5+apalette[i].B*0.3);
           agrau.PalEntry[i].peRed   :=c;
           agrau.PalEntry[i].peGreen :=c;
           agrau.PalEntry[i].peBlue  :=c;
      end;
   // amber

   aamber:=aNewHPalette;
   for i:=0 to pal_entrys
    do
      begin
           c:=trunc(apalette[i].r*0.2+apalette[i].g*0.5+apalette[i].B*0.3);
           aamber.PalEntry[i].peRed   :=c;
           aamber.PalEntry[i].peGreen :=c;
           aamber.PalEntry[i].peBlue  :=0;
      end;

   // Guen
   agruen:=aNewHPalette;
   for i:=0 to pal_entrys
    do
      begin
           c:=trunc(apalette[i].r*0.2+apalette[i].g*0.5+apalette[i].B*0.3);
           agruen.PalEntry[i].peRed   :=0;
           agruen.PalEntry[i].peGreen :=c;
           agruen.PalEntry[i].peBlue  :=0;
      end;

end;

procedure palette_set_color(nr,r,g,b:byte);
begin
     pal_changed:=1;
     aPalette[nr].r:=r;
     aPalette[nr].g:=g;
     aPalette[nr].b:=b;
     openglpal[nr].r:=r / 255;
     openglpal[nr].g:=g / 255;
     openglpal[nr].b:=b / 255;
     palette_set_color16(nr,r,g,b);
end;

procedure changecolor_xxxxBBBBGGGGRRRR(color:byte;data:word);
var r,g,b:byte;
begin

	r:= (data shr  0) and $0f;
	g:= (data shr  4) and $0f;
	b:= (data shr  8) and $0f;


	r:= (r shl  4) or r;
	g:= (g shl  4) or g;
	b:= (b shl  4) or b;

	palette_set_color(color,r,g,b);
end;



procedure changecolor_xxxxRRRRBBBBGGGG(color:byte;data:word);
var r,g,b:byte;
begin

        r:=(data  shr  8) and $0f;
	g:=(data  shr  0) and $0f;
	b:=(data  shr  4) and $0f;

	r:=(r shl 4) or r;
	g:=(g shl 4) or g;
	b:=(b shl 4) or b;

	palette_set_color(color,r,g,b);
end;


Procedure paletteram_BBGGGRRR_w(offs:word;data:byte);
Var
b,g,r:Integer;
bit2,bit1,bit0:Integer;

Begin
  //paletteram[offset] := data;
  bit0 := (data shr 0) and $01;
  bit1 := (data shr 1) and $01;
  bit2 := (data shr 2) and $01;
  r := $21 * bit0 + $47 * bit1 + $97 * bit2;
  bit0 := (data shr 3) and $01;
  bit1 := (data shr 4) and $01;
  bit2 := (data shr 5) and $01;
  g := $21 * bit0 + $47 * bit1 + $97 * bit2;
  bit0 := 0;
  bit1 := (data shr 6) and $01;
  bit2 := (data shr 7) and $01;
  b := $21 * bit0 + $47 * bit1 + $97 * bit2;
  palette_set_color(offs,r,g,b);
end;


var x:byte = 1;
procedure copy_dub_scr(DC: Integer;scr_dub:byte;DIBWidth,DIBHeight,ClientWidth,Clientheight:word);
var i,v,VU:word;
    u:real;

begin

  if OENGL_AKTIVE = 0
  then
   begin
     VU:=ord(DIBWidth < 400);
      x:=x xor 1;
     case scr_dub
     of
       0:  BitBlt(DC,0,0,DIBWidth-(nScrDX shl 1)  ,DIBHeight-nscrdy        ,DIBDC,nScrDX,nscrdy,SRCCOPY);
       1:  for i:=0 to DIBHeight
            do
             if dirty_line[i] = 0
             then
              begin
                   stretchBlt(DC,0,(1+i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1))shl 1,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                   dirty_line[i]:=dirty_lines_on;
              end;
       2:  for i:=0 to DIBHeight
            do
            if dirty_line[i] = 0
             then
             begin
              stretchBlt(DC,0,(1+i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1)) shl 1,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
              stretchBlt(DC,0,(i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1)) shl 1,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
              dirty_line[i]:=dirty_lines_on;
             end;
       4:  for i:=0 to DIBHeight
            do
             if dirty_line[i] = 0
             then
               begin
                 stretchBlt(DC,0 ,(i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1))shl VU,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                 stretchBlt(DC,0 ,(1+i shl 1 )-nScrDy,(DIBWidth-(nScrDX shl 1))  shl VU,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                 dirty_line[i]:=dirty_lines_on;
               end;
       5:  for i:=0 to DIBHeight
            do
             if dirty_line[i] = 0
             then
              begin
                 stretchBlt(DC,0,(1+i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1)) shl VU,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                 dirty_line[i]:=dirty_lines_on;
              end;
         6:  for i:=0 to DIBHeight
            do
             if dirty_line[i] = 0
             then
              begin

                 stretchBlt(DC,0,x+(1+i shl 1)-nScrDy,(DIBWidth-(nScrDX shl 1)) shl VU,1,DIBDC,nScrDX,i,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                 dirty_line[i]:=dirty_lines_on;
              end;

       3: begin
              v:=0;
              u:=((Clientheight-19) / (DIBHeight-64));
              for i:=0 to Clientheight
              do
               begin
                // if dirty_line[V] = 0
                //  then
                  // begin
                    stretchBlt(DC,0,(i)-nScrDy,ClientWidth,1,DIBDC,nScrDX,v,(DIBWidth-(nScrDX shl 1)),1,SRCCOPY);
                    //dirty_line[V]:=dirty_lines_on;
                  // end;
                    if i >= v*u then  inc(V);
               END;
           end;
     end;
   end
  else
   begin

        //glViewport(-60,-5,130+ClientWidth,20+Clientheight); //
        //glViewport(0,0,ClientWidth,Clientheight); // gibt an , auf welchen bereich, des zieles das bild angezeigt werden soll
        //glMatrixMode(GL_MODELVIEW);
        //glLoadIdentity();
        //glTranslatef(0, 0.0, 2.6); // wir gehen Schritte zurck, damit wir was sehen knnen
        //SwapBuffers(DC);
   end;
end;
var i:word;
initialization
  palette:=@apalette;
  for i:=0 to $FFFF do C16Bit_farbtabelle[i]:=0;
  set_bmp_deep(8); // standard
end.

