unit ameise;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg,ExtCtrls,udibsurf, StdCtrls, Menus,sercom,Clipbrd, ComCtrls,Registry,
  m0609fnt,helper;

type
  Tm = class(TForm)
    set_values: TGroupBox;
    Panel16: TPanel;
    GroupBox2: TGroupBox;
    Min: TTrackBar;
    max: TTrackBar;
    Panel1: TPanel;
    Panel5: TPanel;
    Panel8: TPanel;
    GroupBox1: TGroupBox;
    set_skip: TGroupBox;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    CheckBox1: TCheckBox;
    timestemp: TCheckBox;
    Panel9: TPanel;
    GroupBox3: TGroupBox;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel15: TPanel;
    Label1: TLabel;
    Tpass: TTrackBar;
    Ableitung: TCheckBox;
    min_peek: TCheckBox;
    max_peek: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    player: TGroupBox;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    New_file: TPanel;
    framed: TCheckBox;
    message: TLabel;
    Com_ports: TListBox;
    CLR_OFFS: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure Panel4Click(Sender: TObject);
    procedure read_datas;
    procedure read_file_datas(position_:integer);
    procedure draw_first;
    procedure draw_value(M,mode:byte);
    function  seperate_datas(data:string;mode:byte):byte;
    function  detect_frame:byte;
    procedure reset;
    procedure jpmp_pos(eing:integer);
    procedure Panel5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure Panel6Click(Sender: TObject);
    procedure Panel7Click(Sender: TObject);
    procedure MinChange(Sender: TObject);
    procedure maxChange(Sender: TObject);
    procedure Com_portsClick(Sender: TObject);
    procedure TpassChange(Sender: TObject);
    procedure Panel8Click(Sender: TObject);
    procedure Panel9Click(Sender: TObject);
    procedure AbleitungClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel10Click(Sender: TObject);
    procedure Panel11Click(Sender: TObject);
    procedure Panel12Click(Sender: TObject);
    procedure Panel13Click(Sender: TObject);
    procedure Panel14Click(Sender: TObject);
    procedure Panel15Click(Sender: TObject);
    procedure Panel16Click(Sender: TObject);
    procedure Panel20Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Panel17Click(Sender: TObject);
    procedure Panel18Click(Sender: TObject);
    procedure Panel19Click(Sender: TObject);
    procedure Panel21Click(Sender: TObject);
    procedure Panel22Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure New_fileClick(Sender: TObject);
    procedure max_peekClick(Sender: TObject);
    procedure min_peekClick(Sender: TObject);
    procedure framedClick(Sender: TObject);
    procedure CLR_OFFSClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var   y_w:word = 570;
      x_w:word = 680;

type
     scrlin = array[0..1000*1000] of byte;
     y_o    = ^word;

var
  m: Tm;
  sl:^scrlin;
  arr: Array of TCheckBox;

implementation

{$R *.DFM}

procedure transfer;
begin
     BitBlt(m.canvas.handle,0,0,x_w,y_w+5,DIBDC,0,0,SRCCOPY);
end;

procedure Tm.reset;
begin
     EnumComPorts(com_ports.items);
     x:=0;y:=0;
     max.Max:=10;

     Mul:=(y_w) / (maxw-offs);
     FillSurface(31);
     transfer;
     Application.ProcessMessages;
    
end;

procedure Tm.FormCreate(Sender: TObject);
var i:byte;

begin
     fillchar(y_offs[0],100,0);
     m.Top:=20;
     m.Left:=20;
     palset:=1;  (* Palette soll gendert werden *)
     for i := 0 to 31 do begin
        apalette[i].r :=Mz700Colors[i, 1];
        aPalette[i].G :=Mz700Colors[i, 2];
        aPalette[i].B:= MZ700Colors[i, 3];
        pal_change[i]:=0;
     end;
     pal_entrys:=255;

     initpal(31);
     CreateDIBSurf(aNewHPalette,x_w,y_w+50,8);
     init_font_8_9;
     sl:=DIBBits;
     setlength(v_mem,y_w*(x_w+50));
     offs:=400;
     reset;

     SetLength(arr, maxvalues+1);
     for i:=1 to maxvalues do        // die auswahl, welche kanle angezeigt werden
     begin
        arr[i]:=TCheckBox.Create(Self);
        arr[i].parent:=Self;
        arr[i].Checked:=true;
        arr[i].left:=i*20;
        arr[i].Top:=y_w+30;
        arr[i].OnClick:=AbleitungClick;
     end;

     EnumComPorts(com_ports.items);

     Application.ProcessMessages;
     rec_list:=TStringList.Create;  // aufzeichnungsliste erstellen;
end;

procedure Tm.FormDestroy(Sender: TObject);

begin
     DestroyDIBSurf;
     rec_list.Free;
end;

procedure plot(x,y:word;c:byte);
var addr:dword;
begin
     addr:=y*DIBWidth_b+x-2;
     if addr > x_w*(y_w+50) then exit;
     SetPixelFast_mz800(x-2,y,c);
end;

procedure line(y:word;y_old:y_o;n:byte);   // simple line
var i:word;
begin
 if y > y_old^
 then
        for i:=y_old^ to y
         do
           plot(x_w,i,n);

 if y < y_old^
 then
        for i:=y to y_old^
         do
          plot(x_w,i,n);

 y_old^:=y;
end;

procedure set_color;
begin
    move(DIBBits^,v_mem[0],DIBSize);
    change_c_mode(1);
    move(v_mem[0],DIBBits^,DIBSize);
    pal_changed:=0;
end;

procedure Tm.Timer1Timer(Sender: TObject);
begin
      exit;
end;

procedure Tm.Panel1Click(Sender: TObject);
begin
     min.Position:=5;
     offs:=min.Position * 100;
     max.Position:=7;
     maxw:=max.Position * 100;
     set_values.Visible:=false;
     if checkbox2.Checked then set_color;
     if mode = 1 then jpmp_pos(akt_rec_pos);
end;

procedure Tm.Panel2Click(Sender: TObject);
begin
     ex:=1;
     sleep(300);
     err:=SerialStop(port);
     err:=SerialExit(port);

     Com_ports.visible:=true;
     Panel3.visible:=false;
     Panel4.visible:=false;
     m.BorderIcons:=m.BorderIcons +[biSystemMenu];
end;

procedure tm.draw_first;
var i:integer;
    n:byte;
begin
       canvas.Rectangle(x_w,0,x_w+60,y_W+15);
       canvas.Rectangle(x_w+60,0,x_w+140,y_W+15);
       i:=offs-100;

       while (i < maxw) // sicherheit fr das plotten
       do
         begin
              inc(i,100);
              y:=y_w-trunc((I-offs)*Mul);

              if (y < y_w)
                then
                    SetPixelFast_mz800(x_w,y,30);

              if ableitung.Checked
                then
                    canvas.TextOut(x_w+10,y,floattostr((i-(offs+(maxw-offs)/2))*multiplikator)+' mV')
                else
                    canvas.TextOut(x_w+10,y,floattostr(i*multiplikator)+' mV');
         end;

       for i:=1 to maxvalues
       do
         begin
              arr[i].Top:=y_w+20;
              canvas.TextOut(i*20,y_w+8,inttostr(i));
              for n:=0 to 16
                do
                 begin
                   SetPixelFast_mz800(i*20+n,y_w,i);
                   SetPixelFast_mz800(i*20+n,y_w+1,i);
                   SetPixelFast_mz800(i*20+n,y_w+2,i);
                   SetPixelFast_mz800(i*20+n,y_w+3,i);
                   y_min[i]:=$FFFF;
                   y_max[i]:=0;
                 end;
         end;

       canvas.TextOut(x_w+70,2,'C: VAL');
       Application.ProcessMessages;
end;

function read_com:string;
var c:char;
    data:string;
    old_time:real;
    timeout:byte;
begin
          data:='';
          repeat  // mu noch ein timeout bekommen
                old_time:=time;
                repeat
                  begin
                        timeout:=get_sec(time-old_time);
                        err:=SerialRecv(port,c);
                  end
                until (err = 1) or (timeout > 0) or (ex = 1);

                if timeout > 0
                   then
                        begin
                           writeln('COM timeout !!! Fehlernummer:',err);
                           Application.ProcessMessages;
                        end;

                 if c in ['0'..'9',';',#10,#13]
                   then
                     begin
                        Data:=data+c
                     end

          until (c=#10) or (timeout > 0);
        result:=data;
end;

procedure Tm.draw_value(m,mode:byte);
var n:byte;
    temp,
    i:integer;
    temp_str:string;
begin
           if m = 0 then exit;

           temp_str:='';
           n:=0;
           inc(tick);

           if tick mod 100 = 0
           then
            begin

                for i:=0 to y_w
                do
                   plot(x_w-2,i,30);

                if timestemp.Checked
                   then
                    if mode=0 then write_string((x_w div 8)-9,1,TimeToStr(Now))
                    else
                         write_string((x_w div 8)-9,1,copy(rec_list.Strings[tick],1,8));
                end;

           BitBlt(DIBDC,0,0,x_w,y_w,DIBDC,1,0,SRCCOPY);

           while (n < m)
            do
              begin

                inc(n);

                // ---------------  bereichsprfung -------------

                temp_str:=temp_str + copy(inttostr(value[n])+';   ',1,5);

                temp:=value[n];

                if ableitung.Checked
                  then
                       temp:=2+offs+(maxw-offs) div 2 +temp - value_old[n];

                if temp < offs
                then
                    y:=y_w
                else
                    y:=y_w-(trunc((temp-offs+y_offs[n])*Mul));

                if y <= 0 then y:=0;

               if  arr[n].Checked
               then
               begin
                if min_peek.Checked
                    then
                        begin
                              if y_max[n] < y then y_max[n]:=y;
                              if tick and 1 = 1 then plot(x_w,y_max[n],n);
                        end;

                if max_peek.Checked
                    then
                       begin
                            if y_min[n] > y then y_min[n]:=y;
                            if tick and 1 = 1 then plot(x_w,y_min[n],n);
                       end;

                plot(x_w,y,n);

                if CheckBox1.Checked
                    then
                        line(y,@y_old[n],n);
              end;
            end;

          if mode = 0  // nur wenn die daten von der seriellen schnittstelle kommen
          then
          begin
            temp_str:=TimeToStr(Now)+':'+temp_str;//+#10+#13;
            rec_list.Add(temp_str+'0');

            write_string(1,3,inttostr(rec_list.count));

            if rec_list.count > 5000
            then
                save_log(0);
           end;
            if CheckBox3.Checked then
                 write_string(1,1,temp_str);
end;

function tm.seperate_datas(data:string;mode:byte):byte;
var m:word;
    sub:string;
    code,p:integer;
    temp:integer;
begin
         m:=0;
         P:=pos(';',data);
         if mode = 0 then write(DateTimeToStr(Now),' :');
         while (p <> 0) and (m <= maxvalues)
            do
              begin
                  inc(m);
                  P:=pos(';',data);
                  sub:=copy(data,1,p-1);
                  delete(data,1,p);
                  val(sub,temp,code);
                  value_old[m]:=value[m];
                  value_float[m]:=value_float[m]+ (temp - value_float[m])/ mittelwert_zahl;
                  value[m]:=trunc(value_float[m]);
                  if mode = 0 then write(value[m]:4,' ');
                  if mode in [0,2]
                  then
                  begin
                        canvas.TextOut(x_w+70,2+m*15,inttostr(m));
                        canvas.TextOut(x_w+85,2+m*15,': '+'         ');
                        canvas.TextOut(x_w+85,2+m*15,': '+floattostr(value[m]*Multiplikator));
                 end;

              end;
         if mode = 0 then writeln;
        if m >= maxvalues then m:=maxvalues-1;
        result:=m;
end;

function tm.detect_frame:byte;
var i,t,
    m:byte;

begin
     fillchar(y_old[0],100,0);
     message.caption:=('Ermittle Rahmengre '+filler);
     Application.ProcessMessages;
     for i:=0 to 20
     do
       begin
             m:=seperate_datas(read_com,0);
             inc(y_old[m],1);
       end;

      m:=0; t:=0;
      for i:=0 to maxvalues
      do
        begin
            if m < y_old[i]
                then
                   begin
                     m:=y_old[i];
                     t:=i;
                   end;
        end;

        message.caption:=('Rahmenlnge '+inttostr(t)+filler);
        result:=t;
end;

procedure Tm.read_datas;
var
    m:byte;
begin
       running_readdatas:=1;      // mainprocedur luft
       Mul:=(y_w) / (maxw-offs);
       fillchar(y_old[0],100,y_w);
       draw_first;
       tick:=0;                  // wichtig fr den listenindex
       rec_list.clear;           // liste wird gelscht

       if framed.Checked
          then
            begin
                framelaenge:=detect_frame;
                if framelaenge = 0
                then
                   showmessage('Achtung es wurden keine Daten empfangen !!');
            end;

       while (ex = 0)// and (err = 1)
       do
        begin

         tik2:=(tik2 + 1) mod (skip*(1+paused*1000));

         m:=seperate_datas(read_com,0);

          if framed.Checked
          then
              if m <> framelaenge
                  then
                   begin
                        writeln('Rahmenlnge stimmt nicht !! Erwartet :',framelaenge,'  empfangen :',m);
                        m:=0; // verwerfen
                   end;

         if (tik2 = 0)
         then
          begin
               draw_value(m,0);
               transfer;
            end;

          Application.ProcessMessages;
        end;
        running_readdatas:=0;       // durchgelaufen
end;

procedure tm.read_file_datas(position_:integer);
var i:integer;
    m:byte;
begin
     if rec_list.Count = 0 then
        begin
             //showmessage('Liste ist leer');
             exit;
        end;

       running_readdatas:=1;      // mainprocedur luft
       Mul:=(y_w) / (maxw-offs);
       fillchar(y_old[0],100,y_w);

       fillsurface(31);
       draw_first;
       draw_count:=position_;

       akt_rec_pos:=position_;

       if draw_count >= rec_list.Count
        then
            draw_count:=rec_list.Count-1;

       draw_start:=draw_count - x_w;
       if draw_start < 0 then draw_start:= 0;
       tick:=draw_start;

       for i:=draw_start to draw_count
        do
        begin
         m:=seperate_datas(rec_list.Strings[i],1);

         if m >= maxvalues
         then
            m:=maxvalues-1;

        draw_value(m,1);

        end;
        transfer;
        Application.ProcessMessages;

        ex:=1;
        running_readdatas:=0;       // durchgelaufen
end;

procedure Tm.Panel3Click(Sender: TObject);

begin
       Panel3.visible:=false;
       Panel4.visible:=true;
       panel15.Visible:=true;
       paused:=0;
end;

procedure Tm.Panel4Click(Sender: TObject);
begin
     paused:=1;
     Panel4.visible:=false;
     Panel3.visible:=true;
     panel15.Visible:=false;
end;

procedure Tm.Panel5Click(Sender: TObject);
begin
     min.Position:=3;
     offs:=min.Position * 100;
     max.Position:=5;
     maxw:=max.Position * 100;
     set_values.Visible:=false;
     if checkbox2.Checked then set_color;
     if mode = 1 then jpmp_pos(akt_rec_pos);
end;

procedure Tm.RadioButton1Click(Sender: TObject);
begin
      skip:=1;
end;

procedure Tm.RadioButton2Click(Sender: TObject);
begin
      skip:=3
end;

procedure Tm.RadioButton3Click(Sender: TObject);
begin
      skip:=9;
end;

procedure Tm.RadioButton4Click(Sender: TObject);
begin
     skip:=30;
end;

procedure Tm.RadioButton5Click(Sender: TObject);
begin
      skip:=300;
end;

procedure Tm.Panel6Click(Sender: TObject);
begin
     if messagedlg('Wollen sie das wirklich ?',mtError, mbOKCancel, 0) = mrOK
     then
     begin
        reset;
        draw_first;
        rec_list.clear;           // liste wird gelscht
     end;
end;

procedure Tm.Panel7Click(Sender: TObject);
Var
    DSK   : HDC;
    BMP   : TBitmap;
    t_zeit: ^t_str;
    zeit  :string[8];
    f_name:string;
begin
     DSK := m.canvas.Handle;
    t_zeit:=@zeit;
    BMP := TBitmap.Create;
    BMP.Width :=m.Width;
    BMP.Height :=m.Height;
    BitBlt(BMP.Canvas.Handle, 0, 0, BMP.Width, BMP.Height,
           DSK, 0, 0,
           SrcCopy);
    Clipboard.Assign(BMP);
    zeit:=timetostr(now);
    t_zeit^[4]:='_';
    t_zeit^[7]:='_';

    f_name:='ZAP'+Zeit+'.JPG';
    SaveBitmapAsJPEG(BMP,f_name);
    // gibt die lokale Variable picBild wieder frei
    BMP.Free;
    showmessage('der Fensterinhalt ist nun in der Zwischenablage'+#10+#13+
                'und in der Datei:'+f_name);
end;

procedure Tm.MinChange(Sender: TObject);
begin
      if min.Position >= max.Position
        then min.Position:=min.Position-1;
      offs:=min.Position * 100;

      reset;
      draw_first;

      if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.maxChange(Sender: TObject);
begin
     if max.Position <= min.Position
                then
                     max.Position:=min.Position+1;

     maxw:=max.Position * 100;
     reset;
     draw_first;

     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.Com_portsClick(Sender: TObject);
var res:string;
    num:byte;
    count:integer;
    datei:string;
begin
     mode:=0;
     res:=com_ports.items[com_ports.itemindex];

     if res = 'FILE' then
        begin
            datei:=select_file;
           if datei = '' then exit;
           Panel3.visible:=true;
           Com_ports.visible:=false;
           Panel3.visible:=false;
           panel15.Visible:=true;
           player.Visible:=true;
           paused:=0;
           ex:= 0;
           rec_list.LoadFromFile(datei);
           read_file_datas(x_w);
           new_file.Visible:=true;
            mode:=1;
        end
     else
       begin
          delete(res,1,3);
          val(res,num,count);
          port:=SerialInit(num, In_, Out_);
          err:=SerialPara(port,9600,8,1,'n');
          if err <> 0 then
          begin
                showmessage('Port konnte nicht eingestellt werden '+#10+#13+inttostr(err));
                exit;
          end;
          err:=SerialOpen(port);

          if err <> 0 then
          begin
                showmessage('Port konnte nicht geffnet werden'+#10+#13+inttostr(err));
                exit;
          end;

        Panel3.visible:=true;
        Com_ports.visible:=false;
        Panel3.visible:=false;
        Panel4.visible:=true;
        panel15.Visible:=true;
        paused:=0;
        ex:= 0;
        read_datas; // hauptschleife
     end;
end;

procedure Tm.TpassChange(Sender: TObject);
begin
         tpass.SelEnd:=tpass.Position;
         mittelwert_zahl:=tpass.Position;

         if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                //read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.Panel8Click(Sender: TObject);
begin
     max.Position:=10;
     maxw:=max.Position * 100;
     min.Position:=0;
     offs:=min.Position * 100;
     set_values.Visible:=false;
     if checkbox2.Checked then set_color;
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.Panel9Click(Sender: TObject);
begin
     min.Position:=6;
     offs:=min.Position * 100;
     max.Position:=8;
     maxw:=max.Position * 100;
      set_values.Visible:=false;
     if checkbox2.Checked then set_color;
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.AbleitungClick(Sender: TObject);
begin
     draw_first;
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.FormPaint(Sender: TObject);
begin
     draw_first;
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.FormClose(Sender: TObject; var Action: TCloseAction);

begin
      ex:=1;
      sleep(300);
      err:=SerialStop(port);
      err:=SerialExit(port);
      Panel3.visible:=false;
      Panel4.visible:=false;
      if mode = 0 then save_log(1);
      kill_font_8_9;
end;

procedure Tm.Panel10Click(Sender: TObject);
begin
      skip:=1;  set_values.Visible:=false;
      if checkbox2.Checked then set_color;
end;

procedure Tm.Panel11Click(Sender: TObject);
begin
     skip:=3;  set_values.Visible:=false;
     if checkbox2.Checked then set_color;
end;

procedure Tm.Panel12Click(Sender: TObject);
begin
     skip:=9;  set_values.Visible:=false;
     if checkbox2.Checked then set_color;;
end;

procedure Tm.Panel13Click(Sender: TObject);
begin
     skip:=30; set_values.Visible:=false;
     if checkbox2.Checked then set_color;
end;

procedure Tm.Panel14Click(Sender: TObject);
begin
      skip:=300;  set_values.Visible:=false;
      if checkbox2.Checked then set_color;
end;

procedure Tm.Panel15Click(Sender: TObject);
begin
    set_values.Visible:=true;

    if checkbox2.Checked
    then
    begin
    move(DIBBits^,v_mem[0],DIBSize);
    change_c_mode(2);
    move(v_mem[0],DIBBits^,DIBSize);
    pal_changed:=0;
    end;
end;

procedure Tm.Panel16Click(Sender: TObject);
begin
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
     set_values.Visible:=false;
end;

procedure Tm.Panel20Click(Sender: TObject);
begin
     if akt_rec_pos > 100 then  dec(akt_rec_pos,100);
     jpmp_pos(akt_rec_pos);
end;

procedure Tm.FormResize(Sender: TObject);
var tmp:byte;
begin
    tmp:=ex;
    ex:=1;
    sleep(100);
    canvas.Rectangle(0,0,m.Width,m.Height);
    groupbox3.Left:=m.Width - 100;
    groupbox1.Left:=m.Width - 200;
    groupbox1.Top:=m.Height - 130;
    player.Left:=m.Width - 130;
    y_w:=m.Height-100;
    x_w:=m.Width - 300;
    DestroyDIBSurf;  // ertmal den alten Raus
    CreateDIBSurf(aNewHPalette,x_w,y_w+50,8);
    setlength(v_mem,DIBSize);
    message.Top:=y_w+45;
    reset;
    draw_first;
    if mode = 1 then jpmp_pos(akt_rec_pos);
    ex:=tmp;
end;

procedure tm.jpmp_pos(eing:integer);
begin
    draw_first;
    fillsurface(31);
    read_file_datas(eing);
end;

procedure Tm.Panel17Click(Sender: TObject);
begin
     jpmp_pos(x_w);
end;

procedure Tm.Panel18Click(Sender: TObject);
begin
    jpmp_pos(rec_list.count);
end;

procedure Tm.Panel19Click(Sender: TObject);
begin
     inc(akt_rec_pos,100);
     jpmp_pos(akt_rec_pos);
end;

procedure Tm.Panel21Click(Sender: TObject);
begin
     if akt_rec_pos > 2 then  dec(akt_rec_pos,2);
     jpmp_pos(akt_rec_pos);
end;

procedure Tm.Panel22Click(Sender: TObject);
begin
     inc(akt_rec_pos,2);
     jpmp_pos(akt_rec_pos);
end;

procedure offset_values(m:byte);
var i:word;
    max:real;
begin
         fillchar(y_offs[0],100,0);

         max:=0;
         for i:=1 to m
                do
                   if max <= value[i] then max:=value[i];

         for i:=1 to m
         do
              y_offs[i]:=max-value[i];
end;

procedure Tm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var   P: TPoint;
      m:byte;
begin
    Screen.Cursor := crDefault;
    GetCursorPos(P);
    p:=ScreenToClient(P);
    if (p.X >= x_w) or (p.y > y_w) then exit;
    Screen.Cursor :=crcross;

    if (GetKeyState(VK_LBUTTON) < 0) and (mode = 1)
           then
              begin
                          akt_rec_pos:=trunc(p.X*rec_list.Count/x_w);
                          jpmp_pos(akt_rec_pos);
              end
     else

     if (GetKeyState(VK_RBUTTON) < 0) and (mode = 0)
        then
            begin
                if rec_list.Count < 2 then exit;
                m:=seperate_datas(rec_list.Strings[rec_list.Count-1],2);
                offset_values(m);
                //read_file_datas(rec_list.Count);
                ex:=0;
                running_readdatas:=0;
                exit;
            end;

     if (p.x-x_w+draw_count > 0)
     and (p.x-x_w+draw_count+draw_start < rec_list.Count)
       then
         begin
            m:=seperate_datas(rec_list.Strings[p.x-x_w+draw_count+draw_start],2);
            if GetKeyState(VK_RBUTTON) < 0
                 then
                   begin
                        offset_values(m);
                        jpmp_pos(akt_rec_pos);
                   end;
         end;

end;

procedure Tm.New_fileClick(Sender: TObject);
var
    datei:string;
begin
           datei:=select_file;
           if datei = '' then exit;
           rec_list.Clear;
           Panel3.visible:=true;
           paused:=0;
           ex:= 0;
           rec_list.LoadFromFile(datei);
           read_file_datas(x_w);
           jpmp_pos(x_w);
           mode:=1;
end;

procedure Tm.max_peekClick(Sender: TObject);
begin
    if mode = 1 then jpmp_pos(akt_rec_pos);
end;

procedure Tm.min_peekClick(Sender: TObject);
begin
     if mode = 1 then jpmp_pos(akt_rec_pos)
         else
           begin
                read_file_datas(rec_list.Count);
                ex:=0;
           end;
end;

procedure Tm.framedClick(Sender: TObject);
begin
      if framed.Checked
          then framelaenge:=detect_frame;
end;

procedure Tm.CLR_OFFSClick(Sender: TObject);
begin
     fillchar(y_offs[0],100,0);
     jpmp_pos(akt_rec_pos);
     set_values.Visible:=false;
end;

end.
